package jmslexamples;

import java.awt.Frame;

import com.softsynth.jmsl.util.ExponentialInterpolator;
import com.softsynth.jmsl.view.MusicShapeEditor;

public class ExponentialInterpDemo extends Frame {

    /**
     * Build an exponentially rising shape and display in Shape Editor. Each
     * dimension d reflects a steepness value of (d+1)
     */

    public void stop() {
        removeAll();
    }

    public void start() {
        ExponentialInterpolator exp = new ExponentialInterpolator(0.0, 1.0, 600.0, 100.0);

        com.softsynth.jmsl.MusicShape s = new com.softsynth.jmsl.MusicShape(20);
        // first fill with blank data
        for (int i = 0; i < 600; i++) {
            double dar[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            s.add(dar);
        }

        // now load the shape up with real data, increasing the steepness for each
        // dimension
        for (int dim = 0; dim < 20; dim++) {
            exp.setSteepness(dim + 1.0);
            s.setDimensionName(dim, "Steepness= " + (dim + 1));
            // System.out.println(dim+"");
            for (int el = 0; el < 600; el++) {
                s.set(exp.interp((double) el), el, dim);
            }
        }

        MusicShapeEditor se = new MusicShapeEditor();
        se.addMusicShape(s);

        add(se.getComponent());
    }

    public static void main(String[] args) {
        ExponentialInterpDemo demo = new ExponentialInterpDemo();
        demo.start();
        demo.pack();
        demo.setVisible(true);
        demo.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent e) {
                System.exit(0);
            }
        });
    }

}