package jmslexamples;

import javax.swing.JFrame;
import javax.swing.JLabel;

import com.softsynth.jmsl.view.JMSLScrollbar;
import com.softsynth.jmsl.view.JMSLScrollbarProcessor;

/** awt's Scrollbar is weird - unreliable behavior... JMSL has its own which is very stable 
@author Nick Didkovsky and Phil Burk, (c) 1999 Nick Didkovsky and Phil Burk

*/

public class TestJMSLScrollbar extends JFrame implements JMSLScrollbarProcessor {

  	JMSLScrollbar myScrollbar;
  	JLabel valueLabel;

	public void init() {
		// A new scrollbar with this applet as parent, with default value 50, min value 0, max value 100
	   	myScrollbar = new JMSLScrollbar(this, 50, 0, 100);
   		// set the size of the scrollbar
   		myScrollbar.setSize(320, 25);
   		// set the increment that the value will jump when user clicks inside scrollbar
		myScrollbar.setPageIncrement(10);
		// set the increment that the value will jump when user clicks on arrows of scrollbar
		myScrollbar.setLineIncrement(1);
		valueLabel = new JLabel("Scrollbar value");
		add(myScrollbar);
		add(valueLabel);
	}
	
	
	void handleMyScrollbar() {
		valueLabel.setText(myScrollbar.getValue()+"");
	}
	
	/** Any class using a JMSLScrollbar must implement JMSLScrollbarProcessor by defining this method */
    public void JMSLScrollbarValueChanged(JMSLScrollbar jsb) {
		if (jsb == myScrollbar) {
			handleMyScrollbar();
		}
	}

	public static void main(String args[]) {
			TestJMSLScrollbar test = new TestJMSLScrollbar();			 
			test.addWindowListener( 
				new java.awt.event.WindowAdapter() {
					public void windowClosing(java.awt.event.WindowEvent e) {
						System.exit(0);
					}
				});
			
			test.init(); 
			test.setSize(400,100);
			test.setVisible(true);
	}
   	
  }