/*
 * Created on Jul 12, 2008 by Nick
 *
 */
package jmsltestsuite;

import java.awt.*;
import java.awt.geom.Ellipse2D;

import com.softsynth.jmsl.score.Note;
import com.softsynth.jmsl.score.NoteOrnament;

/**
 * NoteOrnament subclasses allows users to create custom classes that draw into the note's Graphics
 * context. This example draws an oval drip below the note. Use zoom in your drawing to ensure that
 * it scales
 */

public class DrippyNoteOrnament extends NoteOrnament {

    public DrippyNoteOrnament() {
        setName("DrippyNoteOrnament");
    }

    public void draw(Graphics g, double zoom, Note n) {
        Graphics2D g2d = (Graphics2D) g;
        double x = n.getDrawingAnchor().getX() + (int) (getXoffset() * zoom);
        double y = n.getDrawingAnchor().getY() + (int) (getYoffset() * zoom);
        g2d.setColor(Color.blue);
        g2d.draw(new Ellipse2D.Double(x, y, (int) (10 * zoom), (int) (80 * zoom)));
        g2d.setColor(Color.black);
    }

}
