/*
 * Created on Nov 21, 2006 
 *
 */
package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.didkovsky.portview.swing.ViewFactorySwing;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.*;

/**
 * Exercise enharmonic spelling of notes.
 * 
 * Create a score with a chromatic scale. 
 * Spell each pitch four different ways:
 * sharp preferred
 * flat preferred
 * sharp preferred, alternate enharmonic
 * flat preferred, alternate enharmonic  
 * 
 * For James Ray
 * 
 * @author Nick Didkovsky, nick@didkovsky.com
 * 
 */
public class EnharmonicNoteTest {

    public static void main(String args[]) {
        JMSL.setViewFactory(new ViewFactorySwing());
        Score score = new Score(1, 800, 600);
        score.addMeasure();
        for (int i = 0; i < 24; i++) {
            double pitch = i + NoteFactory.MIDDLE_C;
            Note n = score.addNote(1, pitch, 1.0, 0.4); // sharp preferred (default)
            
            n = score.addNote(1, pitch, 1.0, 0.4);
            n.setAccPref(Note.ACC_PREFER_FLAT);
            
            n = score.addNote(1, pitch, 1.0, 0.4); // sharp preferred (default)
            n.setAltEnharmonicSpelling(true);
            
            n = score.addNote(1, pitch, 1.0, 0.4);
            n.setAccPref(Note.ACC_PREFER_FLAT);
            n.setAltEnharmonicSpelling(true);

        }
        /*
         * for (int i = 0; i < 24; i++) { double pitch = i + NoteFactory.MIDDLE_C; Note n =
         * score.addNote(0.5, pitch, 1.0, 0.4); n.setEnharmonicSpelling(true); } for (int i = 0; i <
         * 24; i++) { double pitch = i + NoteFactory.MIDDLE_C; Note n = score.addNote(0.5, pitch,
         * 1.0, 0.4); n.setAccPref(Note.ACC_PREFER_FLAT); } for (int i = 0; i < 24; i++) { double
         * pitch = i + NoteFactory.MIDDLE_C; Note n = score.addNote(0.5, pitch, 1.0, 0.4);
         * n.setAccPref(Note.ACC_PREFER_FLAT); n.setEnharmonicSpelling(true); }
         */
        ScoreFrame scoreFrame = new ScoreFrame();
        scoreFrame.addScore(score);
        scoreFrame.pack();
        scoreFrame.setVisible(true);
        scoreFrame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }
}
