package jmsltestsuite;

import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.softsynth.jmsl.Composable;
import com.softsynth.jmsl.Instrument;
import com.softsynth.jmsl.InstrumentPlayable;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.JMSLMixerContainer;
import com.softsynth.jmsl.MusicList;
import com.softsynth.jmsl.SequentialCollection;
import com.softsynth.jmsl.jsyn2.JSynMusicDevice;
import com.softsynth.jmsl.jsyn2.JSynUnitVoiceInstrument;  

public class EvSchedMusicListTest {

	/** Build an instrument and a shape and play it on a JSyn voice.
	 */
	public static void main(String args[]) {
	 

		MusicList list1;
		MusicList list2;

		JSynMusicDevice.instance().open();

		JMSL.clock.setAdvance(0.5);

		JMSLMixerContainer mixer = new JMSLMixerContainer();
		mixer.start();

		JSynUnitVoiceInstrument ins1 = new JSynUnitVoiceInstrument(4, com.softsynth.jmsl.jsyn2.unitvoices.RingModBell.class.getName());	
		mixer.addInstrument(ins1);
		JSynUnitVoiceInstrument ins2 = new JSynUnitVoiceInstrument(4, com.softsynth.jmsl.jsyn2.unitvoices.RingModBell.class.getName());
		mixer.addInstrument(ins2);

		list1 = new MusicList();
		list1.add(new PlayableTestNote(0.125, 62, 0.5, 2.5));
		list1.add(new PlayableTestNote(0.125, 64, 0.5, 2.5));
		list1.add(new PlayableTestNote(0.125, 66, 0.5, 0.5));
		list1.add(new PlayableTestNote(0.125, 68, 0.5, 2.5));
		list1.add(new PlayableTestNote(0.125, 70, 0.5, 1.5));
		list1.add(new PlayableTestNote(0.125, 72, 0.5, 0.5));
		list1.setInstrument(ins1);

		list2 = new MusicList();
		list2.add(new PlayableTestNote(0.125, 65, 0.5, 2.5));
		list2.add(new PlayableTestNote(0.125, 67, 0.5, 2.5));
		list2.add(new PlayableTestNote(0.125, 69, 0.5, 0.5));
		list2.add(new PlayableTestNote(0.125, 71, 0.5, 2.5));
		list2.add(new PlayableTestNote(0.125, 73, 0.5, 1.5));
		list2.add(new PlayableTestNote(0.125, 75, 0.5, 0.5));
		list2.setInstrument(ins2);

		jmsltestsuite.LurkerTest lurk = new jmsltestsuite.LurkerTest();
		list1.addPlayLurker(lurk);
		list2.addPlayLurker(lurk);

		//	ParallelCollection p = new ParallelCollection(list1, list2);
		SequentialCollection col = new SequentialCollection();
		col.add(list1);
		col.add(list2);

		col.setRepeats(10);

		col.launch(JMSL.now() + 2);

		Frame f = new Frame("MusicLists with Lurker posting events to EventScheduler");
		f.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				JMSL.closeMusicDevices();
				System.exit(0);
			}
		});
		f.setSize(600, 200);
		f.setVisible(true);
	}
}

class PlayableTestNote implements InstrumentPlayable {
	double[] dar;

	public PlayableTestNote(double dur, double pitch, double amp, double hold) {
		dar = new double[4];
		dar[0] = dur;
		dar[1] = pitch;
		dar[2] = amp;
		dar[3] = hold;
	}

	public double play(double playTime, Composable parent, Instrument ins) {
		JMSL.out.println("TestPlayable playing at " + playTime);
		return ins.play(playTime, parent.getTimeStretch(), dar);
		//		return playTime + dur * parent.getTimeStretch();
	}

}
