package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.*;

/**
 * Test ledger line visibility
 * 
 * @author Nick Didkovsky and Phil Burk, copyright 2000 Nick Didkovsky and Phil Burk
 */
public class LedgerLineVisibility {

    public static void main(String args[]) {
        int w = 1000;
        int h = 750;
        int numStaves = 1;
        Score score = new Score(numStaves, w, h, "Test Ledger Line Visibility");
        score.addMeasure(4, 4);
        double dur = 1;
        double pitch = 40;
        for (int i = 0; i < 20; i++) {
            Note n = score.addNote(dur, pitch, 0.5, dur * 0.8);
            if (i % 2 == 0) {
                n.setLedgerLinesVisible(false);
            }
            pitch += 3;
        }

        ScoreFrame scoreFrame = new ScoreFrame();
        scoreFrame.addScore(score);
        scoreFrame.setVisible(true);

        scoreFrame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                JMSL.closeMusicDevices();
                System.exit(0);
            }
        });
    }
}