package jmsltestsuite;

import java.io.IOException;

import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.MusicDevice;
import com.softsynth.jmsl.midi.MidiIOFactory;

/**
 * Bring up a frame with a midi init panel. Send a midi sysex message when you
 * click GO button.
 * 
 * @author Nick Didkovsky
 */
public class MidiSysexSendTest {

	public static void main(String args[]) {
		// JMSL.midi = MidiIO_JavaSound.instance();
		MusicDevice dev;
		try {
			dev = new MidiIOFactory().getMidiIO(MidiIOFactory.MidiIO_JAVASOUND);
			dev.open();
			System.out.println("This sends a sysex message");
			byte[] data = { 1, 2, 3, 4, 5 };
			JMSL.midi.sysex(JMSL.realTime(), data);
			JMSL.closeMusicDevices();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		System.out.println("Done, exiting, byebye");
		System.exit(0);
	}

}
