package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.didkovsky.portview.swing.ViewFactorySwing;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.*;

/**
 * 
 * Test various notehead types
 * 
 * @author Nick Didkovsky, copyright 2005 Nick Didkovsky
 */
public class NoteheadsTest {

    Score score;
    int numStaves;

    public NoteheadsTest() {
        int w = 1000;
        int h = 750;
        numStaves = 1;
        score = new Score(numStaves, w, h);
        build();
    }

    int[] headtypes = { Note.NOTEHEAD_X, Note.NOTEHEAD_X_OVAL, Note.NOTEHEAD_WHITE_DIAMOND, Note.NOTEHEAD_BLACK_DIAMOND, Note.NOTEHEAD_X_DIAMOND};

    public void build() {
        score.addMeasure(4, 4);
        for (int i = 0; i < 8; i++) {
            Note n = score.addNote(0.5, 60, 0.5, 0.8);
           
                n.setNoteHeadType(headtypes[i % headtypes.length]);
            
        }
        score.getScoreLayoutManager().setZoom(0.5);
        score.getControlPanel().setZoom(0.5);
    }

    public static void main(String args[]) {
        JMSL.setViewFactory(new ViewFactorySwing());
        NoteheadsTest test = new NoteheadsTest();
        ScoreFrame scoreFrame = new ScoreFrame();
        scoreFrame.addScore(test.score);
        scoreFrame.pack();
        scoreFrame.setVisible(true);
        scoreFrame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
    }

}