package jmsltestsuite;

import java.io.*;

import com.softsynth.midifile.MIDIFileImage;
import com.softsynth.midifile.MIDIFileInputStream;

/** Use softsynth midifile tools to read in a midifile and print out events after they are all parsed 
 * @author Nick Didkovsky 2/3/03
 * */
public class PrintMidiFile {

	public static void main(String[] args) {
		if (args.length != 1) {
			System.out.println("Usage: JMSLTestSuite.PrintMidiFile <filename>");
			System.exit(0);
		}
		String fileName = args[0];
		MIDIFileInputStream parser;
		FileInputStream stream;
		MIDIFileImage image;
		try {
			try {
				stream = new FileInputStream(fileName);
				parser = new MIDIFileInputStream(stream);
				image = new MIDIFileImage();
				parser.addMIDIFileListener(image);
				parser.parse();
				parser.close();
				image.print();

			}
			catch (FileNotFoundException e) {
				System.err.println(e);
			}
			catch (SecurityException e) {
				System.err.println(e);
			}
		}
		catch (IOException e) {
			System.err.println("Caught " + e);
			e.printStackTrace();
		}
	}

}
