package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.Score;
import com.softsynth.jmsl.score.ScoreFrame;

/**
 * Add measures and notes until java out of memeory
 * 
 * 
 * @author Nick Didkovsky
 */
public class ScoreMemoryTest implements Runnable {

	Score score;

	public ScoreMemoryTest(Score score) {
		super();
		this.score = score;
	}

	public static void main(String args[]) {
		int w = 1000;
		int h = 200;
		int numStaves = 1;
		Score score = new Score(numStaves, w, h, "Add Notes To a Score to test memory");
		score.addMeasure(4, 4);

		ScoreFrame scoreFrame = new ScoreFrame();
		scoreFrame.addScore(score);
		scoreFrame.setVisible(true);

		scoreFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				JMSL.closeMusicDevices();
				System.exit(0);
			}
		});

		ScoreMemoryTest test = new ScoreMemoryTest(score);
		test.start();

	}

	private void start() {
		runner = new Thread(this);
		runner.start();
	}

	Thread runner;

	public void run() {
		Runtime runtime = Runtime.getRuntime();
		int mb = 1024 * 1024;
		int totalNotes = 0;

		int numMeasures = 10;
		for (int i = 0; i < numMeasures; i++) {
			int division =128;
			for (int n = 0; n < division; n++) {
				score.addNote(4.0 / division, 60, 0.5, 0.01);
				totalNotes++;
			}
			score.render();
			try {
				Thread.sleep(10);
			} catch (InterruptedException e1) {
			}
			System.out.println("\nTotal measures: " + score.size());
			System.out.println("Total notes: " + totalNotes);
			System.out.println("Used Memory:" + (runtime.totalMemory() - runtime.freeMemory()) / mb);

			// Print free memory
			long freeMem = runtime.freeMemory() / mb;
			System.out.println("Free Memory:" + freeMem);
			if (freeMem < 10) {
				System.out.println("FREE MEM LOW!!!");
			}

			// Print total available memory
			System.out.println("Total Memory:" + runtime.totalMemory() / mb);

			// Print Maximum available memory
			System.out.println("Max Memory:" + runtime.maxMemory() / mb);
		}
	}
}