package jmsltestsuite;

import java.util.Vector;

import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.MusicShape;
import com.softsynth.jmsl.score.Score;
import com.softsynth.jmsl.score.ScoreFrame;
import com.softsynth.jmsl.score.Tempo;
import com.softsynth.jmsl.score.transcribe.BeatDivisionSchemeList;
import com.softsynth.jmsl.score.transcribe.ElementMissedException;
import com.softsynth.jmsl.score.transcribe.SearchPathListExpansionException;
import com.softsynth.jmsl.score.transcribe.TempoTimeSignatureHolder;
import com.softsynth.jmsl.score.transcribe.Transcriber;
import com.softsynth.jmsl.util.TimeSignature;

/**
 
 * 
 * This test examines minute differences in timestamp
 * 
 
 * 
 @author Nick Didkovsky, (c) 2002 Nick Didkovsky, All Rights reserved.
 */

public class TranscribeScore20 {

	

	public static void main(String args[]) {
		JMSL.clock.setAdvance(0.1);
		BeatDivisionSchemeList.defaultSetup();

		
		MusicShape source1 = new MusicShape(4);
		source1.add(0., 45., 103., 0.521739);
		source1.add(0.521739, 52., 81., 0.521739);
		source1.add(1.043478, 41., 82., 0.521739);
		source1.add(1.565217, 50., 82., 0.521739);
		source1.add(2.086956, 48., 82., 2.086956);
		source1.add(2.086956, 45., 83., 2.086956);
		source1.add(4.173912, 45., 103., 0.521739);
		source1.add(4.695651, 52., 81., 0.521739);
		source1.add(5.21739, 41., 82., 0.521739);
		source1.add(5.739129, 50., 82., 0.521739);
		source1.add(6.260868, 48., 82., 2.086956);
		source1.add(6.260868, 45., 83., 2.086956);
		
		MusicShape source2 = new MusicShape(4);
		source2.add(0., 45., 103., 0.521739);
		source2.add(0.521739, 52., 81., 0.521739);
		source2.add(1.043478, 41., 81., 0.521739);
		source2.add(1.565217, 50., 82., 0.521739);
		source2.add(2.086957, 48., 82., 2.086956);
		source2.add(2.086957, 44.5, 83., 2.086956);
		source2.add(4.173913, 45., 103., 0.521739);
		source2.add(4.695652, 52., 81., 0.521739);
		source2.add(5.217391, 41., 82., 0.521739);
		source2.add(5.73913, 50., 82., 0.521739);
		source2.add(6.26087, 48.5, 82., 2.086956);
		source2.add(6.26087, 45.5, 83., 2.086956);

//		source2.add(16.26087, 45.5, 83., 2.086956);
		// 2 staves, width, height
		Score score = new Score(2, 1024, 800);
		score.addMeasure();
		
		Transcriber transcriber = new Transcriber();
//		transcriber.setExtendLastHoldTime(true);  
		
		double ts = new Tempo(115).getTimeStretch();
		 
		Vector tsVector = new Vector();
		tsVector.addElement(new TempoTimeSignatureHolder(new Tempo(115), new TimeSignature(4, 4)));
		transcriber.setTempoTimeSignatures(tsVector);
 
		try {
			score.setCurrentStaffNumber(0);
			transcriber.setScore(score);			
			score.rewind();
			transcriber.setSourceMusicShape(source1);
			transcriber.transcribe();
			
			score.rewind();
			score.setCurrentStaffNumber(1);
			transcriber.setSourceMusicShape(source2);
			transcriber.transcribe();
			
		} catch (ElementMissedException e) {
			e.printStackTrace();
			System.out.println("ERROR: " + e);
			System.exit(0);
		} catch (SearchPathListExpansionException e) {
			e.printStackTrace();
			System.out.println("ERROR: " + e);
			System.exit(0);
		}

		final ScoreFrame f = new ScoreFrame();
		f.addScore(score); 
		f.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				f.quit();
			}
		});

		f.setVisible(true);

	}

}
