package jmsltestsuite;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.util.Vector;

import com.didkovsky.portview.swing.ViewFactorySwing;
import com.softsynth.jmsl.JMSL;
import com.softsynth.jmsl.score.*;
import com.softsynth.jmsl.score.justify.JustifiableNote;

/**
 * 
 * 
 * @author Nick Didkovsky, copyright 2005 Nick Didkovsky
 */
public class TrillWholeNoteBugFixed {

	Score score;
	int numStaves;

	public TrillWholeNoteBugFixed() {
		int w = 1000;
		int h = 300;
		numStaves = 2;

		score = new Score(numStaves, w, h);

		build();
	}

	public void build() {
		score.addMeasure(4, 1);
		for (int i = 0; i < 16; i++) {
			Note n = score.addNote(1.0, 75 + i, 0.5, 0.8);
			n.addMark(Note.MARK_TRILL);
		}
		for (int i = 0; i < 8; i++) {
			Note n = score.addNote(2.0, 75 + i, 0.5, 0.8);
			n.addMark(Note.MARK_TRILL);
		}
		score.rewind();
		score.setCurrentStaffNumber(1);
		for (int i = 0; i < 8; i++) {
			Note n = score.addNote(4.0, 75 + i, 0.5, 0.8);
			n.addMark(Note.MARK_TRILL);
		}
	}

	public static void main(String args[]) {
		JMSL.setViewFactory(new ViewFactorySwing());
		TrillWholeNoteBugFixed st = new TrillWholeNoteBugFixed();
		ScoreFrame scoreFrame = new ScoreFrame();
		scoreFrame.addScore(st.score);
		scoreFrame.pack();
		scoreFrame.setVisible(true);
		scoreFrame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

	}

}