/** 	
	ColToot02.java

	Put three MusicJobs in a SequentialCollection.
	
 * @author Phil Burk and Nick Didkovsky
 */
/*
 * (C) 1997 Phil Burk and Nick Didkovsky, All Rights Reserved
 * JMSL is based upon HMSL (C) Phil Burk, Larry Polansky and David Rosenboom.
 */

package jmsltutorial;

import java.awt.TextArea;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import com.softsynth.jmsl.*;

public class ColToot02 {

    SequentialCollection mySequentialCollection;
    MusicJob mj1;
    MusicJob mj2;
    MusicJob mj3;

    /*
     * Build our hierarchy 
     */
    public void init() {

        // initialize collection with vanilla MusicJobs
        mySequentialCollection = new SequentialCollection();
        mj1 = new MusicJob();
        mj2 = new MusicJob();
        mj3 = new MusicJob();

        MessagePrintingPlayable mppf = new MessagePrintingPlayable("Repeating");
        mj1.addRepeatPlayable(mppf);
        mj2.addRepeatPlayable(mppf);
        mj3.addRepeatPlayable(mppf);

        mj1.setRepeats(2);
        mj2.setRepeats(3);
        mj3.setRepeats(4);

        mj1.setRepeatPause(1.0);
        mj2.setRepeatPause(1.5);
        mj3.setRepeatPause(2.0);

        mySequentialCollection.add(mj1);
        mySequentialCollection.add(mj2);
        mySequentialCollection.add(mj3);

        mySequentialCollection.setRepeats(2);
    }

    public void start() {
        JMSL.clock = new DefaultMusicClock();
        mySequentialCollection.launch(JMSL.now());
    }

    public void stop() {
        mySequentialCollection.finish();
    }

    public static void main(String[] args) {
        ColToot02 colToot02 = new ColToot02();
        colToot02.init();
        colToot02.start();

        JFrame jf = new JFrame("Close to quit");
        jf.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                colToot02.stop();
                jf.setVisible(false);
                System.exit(0);
            }
        });
    }
}
